#-------------------------------------------------------------------------------
#
#                  Oregano Systems - Design & Consulting GesmbH
#
#         Web: http:#oregano.at                 @: support@oregano.at
#
#-------------------------------------------------------------------------------
#-- DESCRIPTION:    unload the altera_cvp module;
#--                 add altera_cvp to the
#--                 blacklist "/etc/modprobe.d/blacklist.conf"
#--                 and reload syn1588 PCIe NIC device driver
#--------------------------------------------------------------------------------
# updates:
# V1.0: WOL: First draft
#
#

# unload modules
echo "unloading altera_cvp"
echo ""
modprobe -r altera_cvp

# check if module altera_cvp is entered in the blacklist, otherwise enter it
if ! grep -xq "blacklist altera_cvp" /etc/modprobe.d/blacklist.conf; then
  echo "" | sudo tee -a  /etc/modprobe.d/blacklist.conf
  echo "adding altera_cvp module to the blacklist /etc/modprobe.d/blacklist.conf"
  echo "# The altera_cvp  module is called for PCI devices that have an Altera ID." | sudo tee -a /etc/modprobe.d/blacklist.conf
  echo "# Every syn1588nic has an Altera PCI ID, therefor the syn1588nic will be" | sudo tee -a /etc/modprobe.d/blacklist.conf
  echo "# registered by the altera_cvp and are no longer available for the syn1588nic driver!" | sudo tee -a /etc/modprobe.d/blacklist.conf
  echo "# To avoid this, blacklist the altera_cvp module." | sudo tee -a /etc/modprobe.d/blacklist.conf
  echo "blacklist altera_cvp" | sudo tee -a  /etc/modprobe.d/blacklist.conf
fi


echo ""
echo "reload syn1588 PCIe NIC device driver"
modprobe -r SyncDriver
modprobe -r syn1588nic
modprobe -a SyncDriver

echo "Done!"



